/*
The Scriptol library
Home page of the compiler: https://www.scriptol.com

The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS"
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is the Scriptol library for the Scriptol compiler.
The Initial Developer of the Original Code is Denis Sureau at Scriptol.com.
*/


#include <stdlib.h>
#include <stdio.h>
#include <string>
#include <ctype.h>
#include <sys/stat.h>
#include <time.h>
#include <math.h>

#ifdef UNIX
#include <unistd.h>
#else
#include <io.h>
#endif


#include <iostream>
#include <vector>
#include <map>

#include "text.hpp"
#include "textarr.hpp"
#include "intarr.hpp"
#include "array64.hpp"
#include "dyn.hpp"
#include "array.hpp"
#include "dict.hpp"
#include "fun.hpp"
#include "soltime.hpp"

/*
  int tm_sec;   // seconds after the minute -- [0,61] 
  int tm_min;   // minutes after the hour   -- [0,59] 
  int tm_hour;  // hours after midnight     -- [0,23] 
  int tm_mday;  // day of the month         -- [1,31] 
  int tm_mon;   / months since January     -- [0,11] 

  int tm_year;  // years since 1900                   
  int tm_wday;  // days since Sunday        -- [0,6]  
  int tm_yday;  // days since January 1     -- [0,365]
  int tm_isdst; // Daylight Savings Time flag 
*/

double _sol_time()
{
	return (double) time(NULL);
}


dict *_sol_ltime()
{
	dict *x = new dict();
	time_t time_of_day;
	struct tm *tmbuf;

	time_of_day = time( NULL );
	tmbuf = localtime( &time_of_day);
	
	x->push("tm_sec", new dyn(tmbuf->tm_sec));
	x->push("tm_min", new dyn(tmbuf->tm_min));		
	x->push("tm_hour", new dyn(tmbuf->tm_hour));		
	x->push("tm_mday", new dyn(tmbuf->tm_mday));		
	x->push("tm_mon", new dyn(tmbuf->tm_mon));			
	x->push("tm_year", new dyn(tmbuf->tm_year));		
	x->push("tm_wday", new dyn(tmbuf->tm_wday));		
	x->push("tm_yday", new dyn(tmbuf->tm_yday));			
	x->push("tm_isdst", new dyn(tmbuf->tm_isdst));			
	return x;	
	
}



